=== modified file 'ChangeLog'
--- ChangeLog	2008-04-07 09:15:03 +0000
+++ ChangeLog	2008-07-16 10:51:00 +0000
@@ -1,3 +1,77 @@
+2008-05-11  KOGURO, Naoki  <naoki@koguro.net>
+
+	* lib/c-wrapper/stubgen.scm.in (run-command): Fixed a typo.
+
+	* lib/c-wrapper/c-grammar.scm, lib/c-wrapper/c-lex.scm: Added
+	@optional and @required rule.
+
+	* Makefile.in, src/Makefile.in, testsuite/Makefile.in,
+	lib/Makefile.in, objc/Makefile.in: Added datarootdir.
+
+2008-05-10  KOGURO, Naoki  <naoki@koguro.net>
+
+	* configure.ac: version 0.5.4
+
+	* lib/c-wrapper/c-parser.scm: Reverted workaround changes for
+	cygwin.
+
+	* src/c-ffilib.stub (<ffi-type>, <ffi-cif>, <ffi-closure>): Removed
+	Scm_TopClass from the define-cclass's cpa. 
+
+2008-05-09  KOGURO, Naoki  <naoki@koguro.net>
+
+	* Makefile.in (install, uninstall): Added $(DESTDIR) to an install
+	directory (Reported by NIIBE Yutaka).
+
+	* src/Makefile.in (libffi/Makefile): Added --with-pic option to
+	libffi's configure (Suggested by NIIBE Yutaka).
+
+	* configure.ac: Made enable_objc flag be effective in Mac OSX.
+
+2008-05-06  KOGURO, Naoki  <naoki@koguro.net>
+
+	* lib/c-wrapper/c-grammar.scm, lib/c-wrapper/c-lex.scm: Added
+	@property, @synthesize and @dynamic rule.
+
+2007-10-30  KOGURO, Naoki  <naoki@koguro.net>
+
+	* src/c-ffilib.stub (<ffi-type>, <ffi-cif>, <ffi-closure>): Added
+	Scm_TopClass to the define-cclass's cpa. This is a workaround for
+	cygwin.
+
+	* configure.ac: Added a cygwin setting.
+
+	* c-parser.scm (typespec->c-type): Added "short unsigned int"
+	pattern.
+
+	* c-parser.scm (make-preprocessed-file,
+	make-macro-file&src-file&identifier-queue): Added a workaround for
+	cygwin.
+
+2007-10-30  KOGURO, Naoki  <naoki@koguro.net>
+
+	* lib/c-wrapper/c-ffi.scm (c-load-library): Changed to hold a
+	handle object (this is for preparing to support Windows).
+
+2007-10-29  KOGURO, Naoki  <naoki@koguro.net>
+
+	* lib/c-wrapper/stubgen.scm.in (run-command): Changed to use
+	run-process instead of with-input-from-process.
+
+	* configure.ac: Stopped making objc-wrapper in MacOSX, because of
+	it doesn't support Objective-C 2.0.
+
+	* c-parser.scm (c-parse): Changed to use run-process instead of
+	call-with-process-io.
+
+	* configure.ac: version 0.5.3
+
+2007-09-15  KOGURO, Naoki  <naoki@koguro.net>
+
+	* src/c-ffilib.stub (ptr->string): Changed to use
+	SCM_MAKE_STR_COPYING instead of SCM_MAKE_STR_IMMUTABLE, because it
+	is difficult to avoid destroying the string body.
+
 2007-05-20  KOGURO, Naoki  <naoki@koguro.net>
 
 	* lib/c-wrapper/c-parser.scm (c-parse): Added ad-hoc support of

=== modified file 'Makefile.in'
--- Makefile.in	2008-04-07 09:15:03 +0000
+++ Makefile.in	2008-07-16 10:51:00 +0000
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile.in 363 2006-12-22 15:54:25Z naoki $
+# $Id: Makefile.in 546 2008-05-11 00:24:56Z naoki $
 #
 
 # General info
@@ -9,6 +9,7 @@
 bindir      = @bindir@
 libdir      = @libdir@
 datadir     = @datadir@
+datarootdir = @datarootdir@
 srcdir      = @srcdir@
 VPATH       = $(srcdir)
 
@@ -49,14 +50,14 @@
 	cd lib; $(MAKE) install
 	cd objc; $(MAKE) install
 	cd doc; $(MAKE) install
-	$(INSTALL) -m 444 -T $(GAUCHE_PKGLIBDIR)/.packages $(PACKAGE).gpd
+	$(INSTALL) -m 444 -T $(DESTDIR)$(GAUCHE_PKGLIBDIR)/.packages $(PACKAGE).gpd
 
 uninstall :
 	cd objc; $(MAKE) uninstall
 	cd src; $(MAKE) uninstall
 	cd lib; $(MAKE) uninstall
 	cd doc; $(MAKE) uninstall
-	$(INSTALL) -U $(GAUCHE_PKGLIBDIR)/.packages $(PACKAGE).gpd
+	$(INSTALL) -U $(DESTDIR)$(GAUCHE_PKGLIBDIR)/.packages $(PACKAGE).gpd
 
 clean :
 	cd src; $(MAKE) clean

=== modified file 'VERSION'
--- VERSION	2008-04-07 09:15:03 +0000
+++ VERSION	2008-07-16 10:51:00 +0000
@@ -1,1 +1,1 @@
-0.5.2
+0.5.4

=== modified file 'configure'
--- configure	2008-04-07 09:15:03 +0000
+++ configure	2008-07-16 10:51:00 +0000
@@ -1,6 +1,6 @@
 #! /bin/sh
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.59 for c-wrapper 0.5.2.
+# Generated by GNU Autoconf 2.59 for c-wrapper 0.5.4.
 #
 # Report bugs to <naoki@koguro.net>.
 #
@@ -269,8 +269,8 @@
 # Identity of this package.
 PACKAGE_NAME='c-wrapper'
 PACKAGE_TARNAME='c-wrapper'
-PACKAGE_VERSION='0.5.2'
-PACKAGE_STRING='c-wrapper 0.5.2'
+PACKAGE_VERSION='0.5.4'
+PACKAGE_STRING='c-wrapper 0.5.4'
 PACKAGE_BUGREPORT='naoki@koguro.net'
 
 ac_subst_vars='SHELL PATH_SEPARATOR PACKAGE_NAME PACKAGE_TARNAME PACKAGE_VERSION PACKAGE_STRING PACKAGE_BUGREPORT exec_prefix prefix program_transform_name bindir sbindir libexecdir datadir sysconfdir sharedstatedir localstatedir libdir includedir oldincludedir infodir mandir build_alias host_alias target_alias DEFS ECHO_C ECHO_N ECHO_T LIBS build build_cpu build_vendor build_os host host_cpu host_vendor host_os target target_cpu target_vendor target_os GOSH GAUCHE_CONFIG GAUCHE_PACKAGE GAUCHE_INSTALL GAUCHE_CESCONV SOEXT OBJEXT EXEEXT DYLIBEXT GAUCHE_PKGINCDIR GAUCHE_PKGLIBDIR GAUCHE_PKGARCHDIR CC CFLAGS LDFLAGS CPPFLAGS ac_ct_CC MAKEINFO GZIP_PROGRAM SED LDCONFIG LD_LIBRARY_PATH_ENVS TESTLIB_CFLAGS TESTLIB_LDFLAGS OBJC_ENABLE_TRUE STUBGEN_FFI_MODULE LDCONFIG_CMD SYS_LIBRARY_PATHS LIBOBJS LTLIBOBJS'
@@ -738,7 +738,7 @@
   # Omit some internal or obsolete options to make the list less imposing.
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-\`configure' configures c-wrapper 0.5.2 to adapt to many kinds of systems.
+\`configure' configures c-wrapper 0.5.4 to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
 
@@ -800,7 +800,7 @@
 
 if test -n "$ac_init_help"; then
   case $ac_init_help in
-     short | recursive ) echo "Configuration of c-wrapper 0.5.2:";;
+     short | recursive ) echo "Configuration of c-wrapper 0.5.4:";;
    esac
   cat <<\_ACEOF
 
@@ -916,7 +916,7 @@
 test -n "$ac_init_help" && exit 0
 if $ac_init_version; then
   cat <<\_ACEOF
-c-wrapper configure 0.5.2
+c-wrapper configure 0.5.4
 generated by GNU Autoconf 2.59
 
 Copyright (C) 2003 Free Software Foundation, Inc.
@@ -930,7 +930,7 @@
 This file contains any messages produced by compilers while
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by c-wrapper $as_me 0.5.2, which was
+It was created by c-wrapper $as_me 0.5.4, which was
 generated by GNU Autoconf 2.59.  Invocation command line was
 
   $ $0 $@
@@ -2695,13 +2695,11 @@
 SYS_LIBRARY_PATHS="/usr/lib /lib"
 case "$target" in
     *darwin*)
-        if test "$enable_objc" != "no"; then
-           enable_objc="yes"
-        fi
         LD_LIBRARY_PATH_ENVS='"LD_LIBRARY_PATH" "DYLD_LIBRARY_PATH"'
-        TESTLIB_CFLAGS="-c -fPIC -o"
-        TESTLIB_LDFLAGS="-dynamiclib -r -nostartfiles -install_name ffitest -single_module -o"
-        STUBGEN_FFI_MODULE=c-wrapper.objc-ffi
+        TESTLIB_LDFLAGS="-dynamiclib -o"
+	if test "$enable_objc" = ""; then
+	    enable_objc="yes"
+	fi
         ;;
     *linux*)
         CPPFLAGS="$CPPFLAGS -D_GNU_SOURCE"
@@ -2714,12 +2712,16 @@
             LDCONFIG_CMD="$LDCONFIG -r | $SED -n '/^	/s/^.*=> //p'"
         fi
         ;;
+    *-cygwin*)
+        LIBS="-lgauche-uvector $LIBS"
+        ;;
 esac
 
 if test "$enable_objc" = "yes"; then
    CPPFLAGS="$CPPFLAGS -x objective-c -fobjc-exceptions"
    LDFLAGS="$LDFLAGS -framework Foundation"
    OBJC_ENABLE_TRUE=""
+   STUBGEN_FFI_MODULE=c-wrapper.objc-ffi
 else
    OBJC_ENABLE_TRUE="#"
 fi
@@ -3133,7 +3135,7 @@
 } >&5
 cat >&5 <<_CSEOF
 
-This file was extended by c-wrapper $as_me 0.5.2, which was
+This file was extended by c-wrapper $as_me 0.5.4, which was
 generated by GNU Autoconf 2.59.  Invocation command line was
 
   CONFIG_FILES    = $CONFIG_FILES
@@ -3188,7 +3190,7 @@
 
 cat >>$CONFIG_STATUS <<_ACEOF
 ac_cs_version="\\
-c-wrapper config.status 0.5.2
+c-wrapper config.status 0.5.4
 configured by $0, generated by GNU Autoconf 2.59,
   with options \\"`echo "$ac_configure_args" | sed 's/[\\""\`\$]/\\\\&/g'`\\"
 

=== modified file 'configure.ac'
--- configure.ac	2008-04-07 09:15:03 +0000
+++ configure.ac	2008-07-16 10:51:00 +0000
@@ -1,11 +1,11 @@
 dnl
 dnl Configuring ffi
 dnl  process this file with autoconf to generate 'configure'.
-dnl $Id: configure.ac 461 2007-05-19 23:22:04Z naoki $
+dnl $Id: configure.ac 545 2008-05-10 14:53:35Z naoki $
 dnl
 
 AC_PREREQ(2.54)
-AC_INIT(c-wrapper, 0.5.2, naoki@koguro.net)
+AC_INIT(c-wrapper, 0.5.4, naoki@koguro.net)
 dnl If you want to use the system name (OS, architecture, etc) in the
 dnl configure, uncomment the following line.  In such a case, you need
 dnl to copy config.guess and config.sub from automake distribution.
@@ -64,13 +64,11 @@
 SYS_LIBRARY_PATHS="/usr/lib /lib"
 case "$target" in
     *darwin*)
-        if test "$enable_objc" != "no"; then
-           enable_objc="yes"
-        fi
         LD_LIBRARY_PATH_ENVS='"LD_LIBRARY_PATH" "DYLD_LIBRARY_PATH"'
-        TESTLIB_CFLAGS="-c -fPIC -o"
-        TESTLIB_LDFLAGS="-dynamiclib -r -nostartfiles -install_name ffitest -single_module -o"
-        STUBGEN_FFI_MODULE=c-wrapper.objc-ffi
+        TESTLIB_LDFLAGS="-dynamiclib -o"
+	if test "$enable_objc" = ""; then
+	    enable_objc="yes"
+	fi	
         ;;
     *linux*)
         CPPFLAGS="$CPPFLAGS -D_GNU_SOURCE"
@@ -83,12 +81,16 @@
             LDCONFIG_CMD="$LDCONFIG -r | $SED -n '/^	/s/^.*=> //p'"
         fi
         ;;
+    *-cygwin*)
+        LIBS="-lgauche-uvector $LIBS"
+        ;;
 esac
 
 if test "$enable_objc" = "yes"; then
    CPPFLAGS="$CPPFLAGS -x objective-c -fobjc-exceptions"
    LDFLAGS="$LDFLAGS -framework Foundation"
    OBJC_ENABLE_TRUE=""
+   STUBGEN_FFI_MODULE=c-wrapper.objc-ffi
 else
    OBJC_ENABLE_TRUE="#"   
 fi

=== modified file 'lib/Makefile.in'
--- lib/Makefile.in	2008-04-07 09:15:03 +0000
+++ lib/Makefile.in	2008-07-16 10:51:00 +0000
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile.in 363 2006-12-22 15:54:25Z naoki $
+# $Id: Makefile.in 546 2008-05-11 00:24:56Z naoki $
 #
 
 # General info
@@ -9,6 +9,7 @@
 bindir      = @bindir@
 libdir      = @libdir@
 datadir     = @datadir@
+datarootdir = @datarootdir@
 srcdir      = @srcdir@
 VPATH       = $(srcdir)
 

=== modified file 'lib/c-wrapper/c-ffi.scm'
--- lib/c-wrapper/c-ffi.scm	2008-04-07 09:15:03 +0000
+++ lib/c-wrapper/c-ffi.scm	2008-07-16 10:51:00 +0000
@@ -38,6 +38,7 @@
   (use c-wrapper.config)
   (use util.match)
   (use util.list)
+  (use gauche.parameter)
 
   (export c-load-library
           c-ld
@@ -136,6 +137,8 @@
 
 (select-module c-wrapper.c-ffi)
 
+(define handle-list (make-parameter '(#f)))
+
 (define (find-dylib-from-la lafile)
   (call-with-input-file lafile
     (lambda (in)
@@ -185,7 +188,7 @@
                    ((#/GROUP\s*\((.*)\)/ str) (#f libs)
                     (or (and-let* ((dl (find (cut #/\.so/ <>)
                                              (string-split libs #[,\s]))))
-                          (dlopen dl (logior RTLD_NOW RTLD_GLOBAL)))
+                          (dlopen dl))
                         #f))
                    (else
                     (loop (read-line in)))))))))
@@ -199,7 +202,7 @@
                                  (find-library lib
                                                (append search-paths
                                                        (sys-library-paths)))))))
-                   (handle (or (dlopen dlfile (logior RTLD_NOW RTLD_GLOBAL))
+                   (handle (or (dlopen dlfile)
                                (try-ld-script dlfile))))
           handle)
         (errorf "can't load ~a ~a" lib (or (and-let* ((errmsg (dlerror)))
@@ -217,7 +220,10 @@
       (define (opt) (car rest-opts))
       (cond
        ((null? rest-opts)
-        (for-each (cut lib-load <> (reverse paths)) (reverse libs)))
+        (for-each (lambda (lib)
+                    (and-let* ([handle (lib-load lib (reverse paths))])
+                      (handle-list (cons handle (handle-list)))))
+                  (reverse libs)))
        ((string-prefix? "-l" (opt))
         (loop (cons (string-append "lib"
                                    (substring (opt) 2 (string-length (opt)))
@@ -247,7 +253,8 @@
   (c-load-library '() :option option))
 
 (define (c-lookup-symbol sym)
-  (dlsym-default (symbol->string sym)))
+  (let ([str (symbol->string sym)])
+    (any (cut dlsym <> str) (handle-list))))
 
 ;; for Objective-C functions
 (define (@ str)

=== modified file 'lib/c-wrapper/c-grammar.scm'
--- lib/c-wrapper/c-grammar.scm	2008-04-07 09:15:03 +0000
+++ lib/c-wrapper/c-grammar.scm	2008-07-16 10:51:00 +0000
@@ -29,7 +29,7 @@
   AT_INTERFACE AT_IMPLEMENTATION AT_END AT_SELECTOR AT_DEFS AT_ENCODE
   AT_PUBLIC AT_PRIVATE AT_PROTECTED AT_PROTOCOL
   AT_CLASS AT_ALIAS AT_THROW AT_TRY AT_CATCH AT_FINALLY AT_SYNCHRONIZED
-  OBJC_STRING
+  AT_PROPERTY AT_SYNTHESIZE AT_DYNAMIC AT_OPTIONAL AT_REQUIRED OBJC_STRING
 
   START_MACRO
   )
@@ -721,6 +721,9 @@
   ()
   (objc_method_prototype_list objc_method_prototype)
   (objc_method_prototype_list external_declaration)
+  (objc_method_prototype_list objc_property)
+  (objc_method_prototype_list AT_OPTIONAL)
+  (objc_method_prototype_list AT_REQUIRED)
   )
 
  (objc_method_prototype
@@ -728,6 +731,19 @@
   : (apply emit-objc-method $2)
   )
 
+ (objc_property
+  (AT_PROPERTY LPAREN property_attribute_list RPAREN declaration)
+  (AT_PROPERTY declaration)
+  (AT_SYNTHESIZE init_declarator_list SEMICOLON)
+  (AT_DYNAMIC init_declarator_list SEMICOLON)
+  )
+
+ (property_attribute_list
+  ()
+  (identifier)
+  (property_attribute_list COMMA identifier)
+  )
+
  (objc_protocol_qualifier
   ()
   (identifier)
@@ -906,7 +922,7 @@
 ;;   (storage_class_specifier)
 ;;   (TYPENAME)
 ;;   (type_qualifier)
-;;   )
-  
+;;   ) 
+ 
  )
 

=== modified file 'lib/c-wrapper/c-lex.scm'
--- lib/c-wrapper/c-lex.scm	2008-04-07 09:15:03 +0000
+++ lib/c-wrapper/c-lex.scm	2008-07-16 10:51:00 +0000
@@ -116,6 +116,11 @@
     (@catch AT_CATCH)
     (@finally AT_FINALLY)
     (@synchronized AT_SYNCHRONIZED)
+    (@property AT_PROPERTY)
+    (@synthesize AT_SYNTHESIZE)
+    (@dynamic AT_DYNAMIC)
+    (@optional AT_OPTIONAL)
+    (@required AT_REQUIRED)
     ))
 
 (define c-operators

=== modified file 'lib/c-wrapper/c-parser.scm'
--- lib/c-wrapper/c-parser.scm	2008-04-07 09:15:03 +0000
+++ lib/c-wrapper/c-parser.scm	2008-07-16 10:51:00 +0000
@@ -31,6 +31,7 @@
 (define-module c-wrapper.c-parser
   (use srfi-1)
   (use srfi-13)
+  (use srfi-11)
   (use gauche.process)
   (use gauche.sequence)
   (use file.util)
@@ -785,6 +786,7 @@
     (('UNSIGNED 'char) '<c-uchar>)
     (('short) '<c-short>)
     (('short 'int) '<c-short>)
+    (('short 'UNSIGNED 'int) '<c-ushort>)
     (('SIGNED 'short) '<c-short>)
     (('SIGNED 'short 'int) '<c-short>)
     (('UNSIGNED 'short) '<c-ushort>)
@@ -1027,28 +1029,28 @@
   (use-return? #f)
   (use-iterator? #f)
   (use-jump? #f)
-  (and-let* ((body (call/cc (lambda (break)
-                              (clear-arg-pool)
-                              (when args
-                                (for-each (lambda (arg)
-                                            (hash-table-put! (arg-pool) arg #t))
-                                          args))
-                              (if body-str
-                                  (with-input-from-string (string-append body-str
-                                                                         ";\n")
-                                    (lambda ()
-                                      (lexer-init (current-input-port))
-                                      (let ((first? #t))
-                                        (c-grammar (lambda ()
-                                                     (cond
-                                                      (first?
-                                                       (set! first? #f)
-                                                       'START_MACRO)
-                                                      (else
-                                                       (c-scan))))
-                                                   (lambda (msg . _)
-                                                     (break #f))))))
-                                  #f)))))
+  (and-let* ((body (call/cc
+                    (lambda (break)
+                      (clear-arg-pool)
+                      (when args
+                        (for-each (lambda (arg)
+                                    (hash-table-put! (arg-pool) arg #t))
+                                  args))
+                      (if body-str
+                          (with-input-from-string (string-append body-str ";\n")
+                            (lambda ()
+                              (lexer-init (current-input-port))
+                              (let ((first? #t))
+                                (c-grammar (lambda ()
+                                             (cond
+                                              (first?
+                                               (set! first? #f)
+                                               'START_MACRO)
+                                              (else
+                                               (c-scan))))
+                                           (lambda (msg . _)
+                                             (break #f))))))
+                          #f)))))
     (cond
      ((or (and (not (use-iterator?)) (use-jump?))
           (use-return?))
@@ -1067,7 +1069,7 @@
 ;; but c-wrapper ignores __attribute__.
 (define (linux?)
   (not (not (#/-linux-/ (gauche-config "--arch")))))
-      
+
 (define (cpp-command include-dirs headers options . rest)
   (let-optionals* rest ((show-define? #t))
     (string-join (append (list GCC "'-D__attribute__(x)=' -E")

=== modified file 'lib/c-wrapper/stubgen.scm'
--- lib/c-wrapper/stubgen.scm	2008-04-07 09:15:03 +0000
+++ lib/c-wrapper/stubgen.scm	2008-07-16 10:51:00 +0000
@@ -494,10 +494,20 @@
          (stub-file (path-swap-extension compiled-lib "stub"))
          (cmdlines (case command
                      ((compile)
-                      (list #`"gauche-package compile ,(if verbose? \"--verbose\" \"\") --cflags=\",|cflags|\" --cppflags=\",|cppflags|\" --ldflags=\",|ldflags|\" --libs=\",|libs|\" ,|extension| ,|stub-file|"))
+                      `(("gauche-package" "compile"
+                         ,@(if verbose? '("--verbose") '())
+                         ,#`"--cflags=,|cflags|"
+                         ,#`"--cppflags=,|cppflags|"
+                         ,#`"--ldflags=,|ldflags|"
+                         ,#`"--libs=,|libs|"
+                         ,extension
+                         ,stub-file)))
                      ((clean)
-                      (list #`"gauche-package compile --clean ,(if verbose? \"--verbose\" \"\") ,|extension| ,|stub-file|"
-                            #`"rm -f ,|stub-file|")))))
+                      `(("gauche-package" "compile" "--clean"
+                         ,@(if verbose? '("--verbose") '())
+                         ,extension
+                         ,stub-file)
+                        ("rm" "-f" ,stub-file))))))
     (parameterize ((stub-unit (make-stub-unit module stub-file)))
       (wrapper->c (listize headers)
                   (listize include-dirs)
@@ -507,10 +517,8 @@
       (write-stub (sys-dirname compiled-lib))
       (for-each (lambda (cmd)
                   (when verbose?
-                    (print cmd))
-                  (with-input-from-process cmd
-                    (lambda ()
-                      (port-for-each print read-line))))
+                    (print (string-join cmd " ")))
+                  (run-process cmd :wait #t))
                 cmdlines))))
 
 (define (compile-wrapper filename command

=== modified file 'lib/c-wrapper/stubgen.scm.in'
--- lib/c-wrapper/stubgen.scm.in	2008-04-07 09:15:03 +0000
+++ lib/c-wrapper/stubgen.scm.in	2008-07-16 10:51:00 +0000
@@ -494,10 +494,20 @@
          (stub-file (path-swap-extension compiled-lib "stub"))
          (cmdlines (case command
                      ((compile)
-                      (list #`"gauche-package compile ,(if verbose? \"--verbose\" \"\") --cflags=\",|cflags|\" --cppflags=\",|cppflags|\" --ldflags=\",|ldflags|\" --libs=\",|libs|\" ,|extension| ,|stub-file|"))
+                      `(("gauche-package" "compile"
+                         ,@(if verbose? '("--verbose") '())
+                         ,#`"--cflags=,|cflags|"
+                         ,#`"--cppflags=,|cppflags|"
+                         ,#`"--ldflags=,|ldflags|"
+                         ,#`"--libs=,|libs|"
+                         ,extension
+                         ,stub-file)))
                      ((clean)
-                      (list #`"gauche-package compile --clean ,(if verbose? \"--verbose\" \"\") ,|extension| ,|stub-file|"
-                            #`"rm -f ,|stub-file|")))))
+                      `(("gauche-package" "compile" "--clean"
+                         ,@(if verbose? '("--verbose") '())
+                         ,extension
+                         ,stub-file)
+                        ("rm" "-f" ,stub-file))))))
     (parameterize ((stub-unit (make-stub-unit module stub-file)))
       (wrapper->c (listize headers)
                   (listize include-dirs)
@@ -507,10 +517,8 @@
       (write-stub (sys-dirname compiled-lib))
       (for-each (lambda (cmd)
                   (when verbose?
-                    (print cmd))
-                  (with-input-from-process cmd
-                    (lambda ()
-                      (port-for-each print read-line))))
+                    (print (string-join cmd " ")))
+                  (run-process cmd :wait #t))
                 cmdlines))))
 
 (define (compile-wrapper filename command

=== modified file 'objc/Makefile.in'
--- objc/Makefile.in	2008-04-07 09:15:03 +0000
+++ objc/Makefile.in	2008-07-16 10:51:00 +0000
@@ -9,6 +9,7 @@
 bindir      = @bindir@
 libdir      = @libdir@
 datadir     = @datadir@
+datarootdir = @datarootdir@
 srcdir      = @srcdir@
 VPATH       = $(srcdir)
 

=== modified file 'src/Makefile.in'
--- src/Makefile.in	2008-04-07 09:15:03 +0000
+++ src/Makefile.in	2008-07-16 10:51:00 +0000
@@ -1,5 +1,5 @@
 #
-# $Id: Makefile.in 365 2006-12-22 23:24:14Z naoki $
+# $Id: Makefile.in 546 2008-05-11 00:24:56Z naoki $
 #
 
 # General info
@@ -9,6 +9,7 @@
 bindir      = @bindir@
 libdir      = @libdir@
 datadir     = @datadir@
+datarootdir = @datarootdir@
 srcdir      = @srcdir@
 VPATH       = $(srcdir)
 
@@ -51,7 +52,7 @@
 
 libffi/Makefile:
 	mkdir -p libffi
-	cd libffi; ../../libffi/configure
+	cd libffi; ../../libffi/configure --with-pic
 
 libffi/.libs/libffi.a: libffi/Makefile
 	cd libffi; $(MAKE)

=== modified file 'src/c-ffi.h'
--- src/c-ffi.h	2008-04-07 09:15:03 +0000
+++ src/c-ffi.h	2008-07-16 10:51:00 +0000
@@ -25,7 +25,7 @@
  *   OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
  *   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  *  
- *   $Id: c-ffi.h 365 2006-12-22 23:24:14Z naoki $
+ *   $Id: c-ffi.h 536 2007-11-03 06:24:57Z naoki $
  */
 
 /* Prologue */
@@ -40,6 +40,10 @@
 #include <gauche/class.h>
 #include <gauche/uvector.h>
 
+#if defined(GAUCHE_WINDOWS)
+#include <windows.h>
+#endif
+
 #include <ffi.h>
 
 #ifdef __OBJC__

=== modified file 'src/c-ffilib.stub'
--- src/c-ffilib.stub	2008-04-07 09:15:03 +0000
+++ src/c-ffilib.stub	2008-07-16 10:51:00 +0000
@@ -26,7 +26,7 @@
 ;;  OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 ;;  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 ;; 
-;;  $Id: c-ffilib.stub 379 2007-01-02 13:58:58Z naoki $
+;;  $Id: c-ffilib.stub 544 2008-05-10 04:11:41Z naoki $
 
 "
 #include \"c-ffi.h\"
@@ -159,7 +159,7 @@
   (call "Scm_Deref"))
 
 (define-cproc ptr->string (ptrObj)
-  (code "SCM_RETURN(SCM_MAKE_STR_IMMUTABLE((const char*) POINTER_DATA(ptrObj)));"))
+  (code "SCM_RETURN(SCM_MAKE_STR_COPYING((const char*) POINTER_DATA(ptrObj)));"))
 
 (define-cproc %expand-u8vector (buf::<uvector> size::<long>)
   (code "SCM_RETURN(Scm_MakeU8VectorFromArrayShared(size, SCM_U8VECTOR_ELEMENTS(buf)));"))
@@ -205,13 +205,12 @@
 ;;
 ;; dlopen, dlsym, dlclose
 ;;
-(define-enum RTLD_LAZY)
-(define-enum RTLD_NOW)
-(define-enum RTLD_GLOBAL)
-(define-enum RTLD_LOCAL)
-
-(define-cproc dlopen (path::<const-cstring> mode::<fixnum>)
-  (code "void *handle = dlopen(path, mode);"
+(define-cproc dlopen (path::<const-cstring>)
+  (code "#if defined(GAUCHE_WINDOWS)"
+        "void *handle = (void*)LoadLibrary(SCM_MBS2WCS(path));"
+        "#else"
+        "void *handle = dlopen(path, RTLD_NOW | RTLD_GLOBAL);"
+        "#endif"
         "if (handle) {"
         "    SCM_RETURN(MAKE_VOID_POINTER(handle));"
         "} else {"
@@ -219,15 +218,20 @@
         "}"))
 
 (define-cproc dlsym (handle symbol::<const-cstring>)
-  (code "void *ptr = dlsym(POINTER_DATA(handle), symbol);"
-        "if (ptr) {"
-        "    SCM_RETURN(MAKE_VOID_POINTER(ptr));"
+  (code "void *ptr;"
+        "if (SCM_FALSEP(handle)) {"
+        "#if defined(GAUCHE_WINDOWS)"
+        "    ptr = NULL;"
+        "#else"
+        "    ptr = dlsym(RTLD_DEFAULT, symbol);"
+        "#endif"
         "} else {"
-        "    SCM_RETURN(SCM_FALSE);"
-        "}"))
-
-(define-cproc dlsym-default (symbol::<const-cstring>)
-  (code "void *ptr = dlsym(RTLD_DEFAULT, symbol);"
+        "#if defined(GAUCHE_WINDOWS)"
+        "    ptr = (void*) GetProcAddress((HMODULE) handle, symbol);"
+        "#else"
+        "    ptr = dlsym(POINTER_DATA(handle), symbol);"
+        "#endif"
+        "}"
         "if (ptr) {"
         "    SCM_RETURN(MAKE_VOID_POINTER(ptr));"
         "} else {"
@@ -235,15 +239,26 @@
         "}"))
 
 (define-cproc dlerror ()
-  (code "const char *errmsg = dlerror();"
+  (code "#if defined(GAUCHE_WINDOWS)"
+        "char buf[80];"
+        "sprintf(buf, \"error code %d\", GetLastError());"
+        "SCM_RETURN(SCM_MAKE_STR_COPYING(buf));"
+        "#else"
+        "const char *errmsg = dlerror();"
         "if (errmsg) {"
         "    SCM_RETURN(SCM_MAKE_STR_IMMUTABLE(errmsg));"
         "} else {"
         "    SCM_RETURN(SCM_FALSE);"
-        "}"))
+        "}"
+        "#endif"))
 
 (define-cproc dlclose (handle)
-  (code "SCM_RETURN(SCM_MAKE_INT(dlclose(POINTER_DATA(handle))));"))
+  (code "#if defined(GAUCHE_WINDOWS)"
+        "(void)FreeLibrary((HMODULE) handle);"
+        "SCM_RETURN(SCM_MAKE_INT(0));"
+        "#else"
+        "SCM_RETURN(SCM_MAKE_INT(dlclose(POINTER_DATA(handle))));"
+        "#endif"))
 
 ;;
 ;; others

=== modified file 'testsuite/Makefile.in'
--- testsuite/Makefile.in	2008-04-07 09:15:03 +0000
+++ testsuite/Makefile.in	2008-07-16 10:51:00 +0000
@@ -9,6 +9,7 @@
 bindir      = @bindir@
 libdir      = @libdir@
 datadir     = @datadir@
+datarootdir = @datarootdir@
 srcdir      = @srcdir@
 VPATH       = $(srcdir)
 

=== modified file 'testsuite/ffitest.scm'
--- testsuite/ffitest.scm	2008-04-07 09:15:03 +0000
+++ testsuite/ffitest.scm	2008-07-16 10:51:00 +0000
@@ -24,7 +24,7 @@
 (test "dlopen"
       #f
       (lambda ()
-        (let ((handle (dlopen DYLIB (with-module c-wrapper RTLD_NOW))))
+        (let ((handle (dlopen DYLIB)))
           (begin0
             (null-ptr? handle)
             (dlclose handle)))))
@@ -33,7 +33,7 @@
 (test "dlsym"
       #f
       (lambda ()
-        (let* ((handle (dlopen DYLIB (with-module c-wrapper RTLD_NOW)))
+        (let* ((handle (dlopen DYLIB))
                (ptr (dlsym handle "add_uint")))
           (begin0
             (null-ptr? ptr)
@@ -42,7 +42,7 @@
 (test "ffi_prep_cif"
       (with-module c-wrapper FFI_OK)
       (lambda ()
-        (let* ((handle (dlopen DYLIB (with-module c-wrapper RTLD_NOW)))
+        (let* ((handle (dlopen DYLIB))
                (fn (dlsym handle "add_uint")))
           (receive (status cif)
               (ffi-prep-cif (ffi-type-uint) (list (ffi-type-uint)
@@ -54,7 +54,7 @@
 (test "ffi_call"
       3
       (lambda ()
-        (let* ((handle (dlopen DYLIB (with-module c-wrapper RTLD_NOW)))
+        (let* ((handle (dlopen DYLIB))
                (fn (dlsym handle "add_uint"))
                (rvalue (make <c-uint>))
                (v1 (make <c-uint>))
@@ -73,7 +73,7 @@
 (test "ffi_closure"
       #t
       (lambda ()
-        (let* ((handle (dlopen DYLIB (with-module c-wrapper RTLD_NOW)))
+        (let* ((handle (dlopen DYLIB))
                (fn (dlsym handle "callback")))
           (receive (status cif)
               (ffi-prep-cif (ffi-type-sint) (list (ffi-type-sint)
@@ -93,7 +93,7 @@
 (test "call callback"
       5
       (lambda ()
-        (let* ((handle (dlopen DYLIB (with-module c-wrapper RTLD_NOW)))
+        (let* ((handle (dlopen DYLIB))
                (fn (dlsym handle "callback_sint"))
                (v1 (make <c-int>))
                (v2 (make <c-int>))

